<template>
  <div class="upload-container">
    <el-col
      v-if="!select.isTrue && select.props && select.props.length > 0"
      :span="24"
      class="toolbar"
    >
      <el-form
        :inline="true"
        :model="select.filters"
      >
        <el-form-item
          v-for="(item, index) in select.props"
          :key="index"
          :class="item.all"
        >
          <el-input
            v-if="item.type === 'input'"
            v-model="select.filters[item.prop]"
            :placeholder="item.placeholder"
            :style="item.style"
            class="filter-item"
          />
          <el-select
            v-if="item.type === 'select'"
            v-model="select.filters[item.prop]"
            :placeholder="item.placeholder"
            :style="item.style"
            class="filter-item"
            clearable
          >
            <el-option
              v-for="oitem in item.data"
              :key="oitem.value"
              :label="oitem.label"
              :value="oitem.value"
            />
          </el-select>
          <el-date-picker
            v-if="item.type === 'year-month'"
            v-model="select.filters[item.prop]"
            :placeholder="item.placeholder"
            :value-format="item.vformat || 'yyyy-MM'"
            type="month"
          />
          <el-date-picker
            v-if="item.type === 'year-month-day'"
            v-model="select.filters[item.prop]"
            :placeholder="item.placeholder"
            :value-format="item.vformat || 'yyyy-MM-dd'"
            type="date"
          />
          <el-date-picker
            v-if="item.type === 'year-month-day-two'"
            v-model="ymdTwo"
            :end-placeholder="item.eplaceholder || item.eplaceholder"
            :placeholder="item.placeholder"
            :range-separator="item.pickeseparator || '~'"
            :start-placeholder="item.splaceholder || item.splaceholder"
            :value-format="item.vformat || 'yyyy-MM-dd'"
            type="daterange"
            @change="ymdTwoChange(item)"
          />
          <el-cascader
            v-if="item.type === 'cascader'"
            v-model="select.filters[item.prop]"
            :options="item.options"
            :placeholder="item.placeholder"
            :props="item.props"
            @change="cascaderChange(item.prop)"
          />
          <el-button
            v-if="item.type === 'btn'"
            :type="item.class"
            @click="item.click ? item.click() : ''"
          >
            {{ item.label }}
          </el-button>
          <el-button
            v-if="item.type === 'enbtn'"
            :type="item.class"
            @click="item.click ? item.click() : ''"
            @keyup.enter.native="item.click ? item.click() : ''"
          >
            {{ item.label }}
          </el-button>
          <el-button
            v-if="item.type === 'reBtn'"
            :type="item.class"
            @click="reButn(item)"
          >
            {{ item.label || '重置' }}
          </el-button>
        </el-form-item>
      </el-form>
    </el-col>
    <el-col
      v-if="!tabs.isTrue"
      class="group"
    >
      <div
        v-for="(item, index) in tabs.data"
        :key="index"
        :class="index === tabs.index ? 'is_action' : ''"
        @click="clickTabs(index, item)"
      >
        {{ item }}
      </div>
    </el-col>
    <el-table
      v-if="!table.isTrue"
      v-loading="loading"
      :data="getTableData"
      fit
      highlight-current-row
      style="width: 100%;"
      @row-dblclick="dbClickRow"
    >
      <el-table-column
        v-for="(item, index) in table.props"
        :key="index"
        :label="item.label"
        :prop="item.prop"
        :render-header="(h, obj) => renderHeader(h, obj, item.renderHeader)"
        :type="item.type"
        :width="item.width || ''"
        align="center"
        sortable
      >
        <template slot-scope="scope">
          <div v-if="item.button">
            <el-button
              v-for="(bitem, bindex) in item.button"
              :key="`b${bindex}`"
              :class="bitem.class || 'filter-item'"
              :size="bitem.size || 'small'"
              :type="bitem.type || 'text'"
              @click="btnClick(scope.row, bitem)"
            >
              {{ lableChange(bitem, item, scope.row ) }}
            </el-button>
          </div>
          <div v-else-if="item.a">
            <el-link
              v-for="(bitem, bindex) in item.a"
              :key="`b${bindex}`"
              :class="bitem.class || 'filter-item'"
              :size="bitem.size || 'small'"
              :type="bitem.type || 'text'"
              :underline="false"
              style="margin-right: 10px"
              @click="btnClick(scope.row, bitem)"
            >
              {{ lableChange(bitem, item, scope.row ) }}
            </el-link>
          </div>
          <div
            v-else-if="item.image"
            class="imgs"
          >
            <el-avatar
              :size="item.size || 80"
              :src="scope.row[item.image]"
              fit="fit"
              shape="square"
            />
            <span
              style="margin-left: 10px"
            >{{ item.change ? item.change(scope.row[item.prop]) : item.prop ? scope.row[item.prop] : `${ scope.$index + 1 }` }}</span>
          </div>
          <span
            v-else
          >{{ item.change ? item.change(scope.row[item.prop]) : item.prop ? scope.row[item.prop] : `${ scope.$index + 1 }` }}</span>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-if="pagination.click"
      :limit.sync="pagination.showCount"
      :page.sync="pagination.currentPage"
      :total="paginationTotal"
      @pagination="paginationClick"
    />
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'
import Pagination from '@/components/Pagination/index.vue'

@Component({
  name: 'Utable',
  components: {
    Pagination
  }
})
export default class extends Vue {
  private tabPosition = {}
  private cascader = {} as any
  @Prop({ default: () => ({ isTrue: true }) }) private table!: _comUtable.table
  @Prop({ default: () => ({ isTrue: true }) })
  private select!: _comUtable.select

  @Prop({ default: () => ({ isTrue: true }) })
  private pagination!: _comUtable.pagination

  @Prop({ default: () => ({ isTrue: true }) })
  private tabs!: _comUtable.tabs

  public loading = false as boolean
  private ymdTwo = [] as string[]

  btnClick(row: any, item: _comUtable.button) {
    if (item.click) this.click(item.click, row)
    if (item.lclick) this.lclick(item.lclick, row)
  }

  async lclick(fun: Function, row: any) {
    this.loading = true
    await fun(row)
    this.loading = false
  }

  get getTableData() {
    let tableData = [] as any[]
    if (this.table.tableData) tableData = this.table.tableData
    if (this.table.tableDataU && this.table.tableDataU.data) { tableData = this.table.tableDataU.data.rows || [] }
    return tableData
  }

  renderHeader(h: any, { column }: any, content: string) {
    if (!content) return [column.label]
    return [
      column.label,
      h(
        'el-tooltip',
        {
          props: {
            content: content,
            placement: 'top'
          }
        },
        [h('span', { class: { 'el-icon-question': true } })]
      )
    ]
  }

  click(fun: Function, row: any) {
    fun(row)
  }

  clickTabs(index: number, item: _comUtable.tabs) {
    this.tabs.index = index
    item.click()
  }

  // 处理级联选择
  cascaderChange() {
    // console.info(this.cascader[prop])
    // this.select.filters[props] =
  }

  // 日期处理
  ymdTwoChange(item: any) {
    if (!this.select.filters) return
    this.select.filters[item.prop1] = this.ymdTwo[0]
    this.select.filters[item.prop2] = this.ymdTwo[1]
  }

  // 分页 事件处理
  async paginationClick(data: any) {
    if (this.pagination.currentPage) this.pagination.currentPage = data.page
    if (this.pagination.showCount) this.pagination.showCount = data.limit
    if (!this.select.isTrue) {
      this.select.filters.currentPage = data.page
      this.select.filters.showCount = data.limit
    }
    if (this.pagination.click) this.pagination.click()
  }

  get paginationTotal() {
    let total = 0 as number
    if (this.pagination && this.pagination.total !== undefined) {
      total = this.pagination.total
    }
    if (this.table.tableDataU && this.table.tableDataU.data) {
      total = this.table.tableDataU.data.total || 0
    }
    // console.info('paginationTotal', total)
    return total
  }

  // 重置
  reButn(item: _comUtable.selectProps) {
    this.ymdTwo = []
    this.select.filters = JSON.parse(JSON.stringify(this.select.filtersOld))
    if (item.click) item.click()
  }

  created() {
    if (this.select.filters) { this.select.filtersOld = JSON.parse(JSON.stringify(this.select.filters)) }

    // 分页处理
    if (this.select.filters) {
      this.pagination.showCount = this.select.filters.showCount
      this.pagination.currentPage = this.select.filters.currentPage
    }
  }

  // 双击表格
  dbClickRow(row: any) {
    if (this.table.dbClickRow) this.table.dbClickRow(row)
  }

  lableChange(bitem: _comUtable.button, item: _comUtable.props, row: any) {
    const lable = item.prop ? row[item.prop] : bitem.label
    return lable
  }
}
</script>

<style lang="scss" scoped>
.imgs {
  display: flex;
  padding-left: 100px;
  align-items: center;
  > span:nth-child(2) {
    margin-left: 10px;
  }
}
.el-form {
  position: relative;
}
.btn {
  position: absolute;
  right: 0;
  bottom: 0;
}
.group {
  display: flex;
  min-height: 10px;
  div {
    background-color: #fff;
    color: #606266;
    cursor: pointer;
    padding: 12px 20px;
    font-size: 14px;
    border: 1px solid #dcdfe6;
    border-right: 0px;
    font-weight: 500;
    transition: all .3s cubic-bezier(.645,.045,.355,1);
    font-family: Helvetica Neue,Helvetica,PingFang SC,Hiragino Sans GB,Microsoft YaHei,SimSun,sans-serif;
  }
  >div:last-child {
    border-right: 1px solid #dcdfe6;
  }
  .is_action {
    color: #fff;
    background-color: #409eff;
    border-color: #409eff;
    box-shadow: -1px 0 0 0 #409eff;
  }
}

</style>
